using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace XNA_Gestures2
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        Texture2D mainScreen;
        Texture2D additionalScreen;
        int iFirst;
        int iLast;
        bool boIsHorizontal;
        int iCurScreen;
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            graphics.IsFullScreen = true;
            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            TouchPanel.EnabledGestures = GestureType.VerticalDrag | GestureType.HorizontalDrag | GestureType.DragComplete;
            iFirst = -1;
            iLast = -1;
            boIsHorizontal = false;
            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            mainScreen = Content.Load<Texture2D>("main");
            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here
            while (TouchPanel.IsGestureAvailable)
            {
                // read the next gesture from the queue
                GestureSample gesture = TouchPanel.ReadGesture();

                // we can use the type of gesture to determine our behavior
                switch (gesture.GestureType)
                {
                    case GestureType.HorizontalDrag:
                        boIsHorizontal = true;
                        if (iFirst == -1)
                            iFirst = (int)gesture.Position.X;
                        iLast = (int)gesture.Position.X;
                        break;
                    case GestureType.VerticalDrag:
                        boIsHorizontal = false;
                        if (iFirst == -1)
                            iFirst = (int)gesture.Position.Y;
                        iLast = (int)gesture.Position.Y;
                        break;
                    case GestureType.DragComplete:
                        if (iCurScreen > 0)
                        {
                            if (boIsHorizontal)
                            {
                                if (iCurScreen == 1 || iCurScreen == 2)
                                {
                                    switch (iCurScreen)
                                    {
                                        case 1:
                                            if (iFirst < iLast)
                                            {
                                                additionalScreen = null;
                                                iCurScreen = 0;
                                            }
                                            break;
                                        case 2:
                                            if (iFirst > iLast)
                                            {
                                                additionalScreen = null;
                                                iCurScreen = 0;
                                            }
                                            break;
                                        default:
                                            break;
                                    }
                                    additionalScreen = null;
                                    iCurScreen = 0;
                                }
                            }
                            else
                            {
                                if (iCurScreen == 3 || iCurScreen == 4)
                                {
                                    switch (iCurScreen)
                                    {
                                        case 3:
                                            if (iFirst > iLast)
                                            {
                                                additionalScreen = null;
                                                iCurScreen = 0;
                                            }
                                            break;
                                        case 4:
                                            if (iFirst < iLast)
                                            {
                                                additionalScreen = null;
                                                iCurScreen = 0;
                                            }
                                            break;
                                        default:
                                            break;
                                    }
                                }
                            }
                            iFirst = -1;
                            iLast = -1;
                        }
                        else
                        {
                            if (boIsHorizontal)
                            {
                                if (iFirst < iLast)
                                {
                                    additionalScreen = Content.Load<Texture2D>("rechts");
                                    iCurScreen = 1;
                                }
                                else
                                {
                                    additionalScreen = Content.Load<Texture2D>("links");
                                    iCurScreen = 2;
                                }
                            }
                            else
                            {
                                if (iFirst < iLast)
                                {
                                    additionalScreen = Content.Load<Texture2D>("oben");
                                    iCurScreen = 3;
                                }
                                else
                                {
                                    additionalScreen = Content.Load<Texture2D>("unten");
                                    iCurScreen = 4;
                                }
                            }
                            iFirst = -1;
                            iLast = -1;
                        }
                        break;
                }
            }
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here
            spriteBatch.Begin();
            
            spriteBatch.Draw(mainScreen, new Vector2(0, 0), Color.White);
            if (additionalScreen != null)
                spriteBatch.Draw(additionalScreen, new Vector2(0, 0), Color.White);
            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
